:: Bankix2Flash Version 1.3.0 
:: Batch-Skript, das die Bankix Linux Distribution der Zeitschrift c't auf einen USB-Stick
:: oder eine SD-Karte installiert.
:: Copyright (C) 2012 Madnex
:: Letzte nderung: 10.11.2012

:: Dieses Batch-Skript ist freie Software. Sie knnen es unter den Bedingungen der GNU General
:: Public License, wie von der Free Software Foundation verffentlicht, weitergeben und/oder
:: modifizieren, entweder gem Version 2 der Lizenz oder (nach Ihrer Option) jeder spteren
:: Version.

:: Die Verffentlichung dieses Programms erfolgt in der Hoffnung, dass es Ihnen von Nutzen
:: sein wird, aber OHNE IRGENDEINE GARANTIE, sogar ohne die implizite Garantie der MARKTREIFE
:: oder der VERWENDBARKEIT FR EINEN BESTIMMTEN ZWECK. Details finden Sie in der GNU General
:: Public License.

:: Sie sollten ein Exemplar der GNU General Public License zusammen mit diesem Programm
:: erhalten haben. Falls nicht, siehe <http://www.gnu.org/licenses/>.

@ECHO OFF & SETLOCAL
SET Bix2FVer=v1.3.0

:: Standard-Driveletter (kann bei Bedarf angepasst werden)
:: Setzt den Laufwerksbuchstaben fr das Ziel fest. Ein anderer Laufwerksbuchstabe kann durch
:: das Aufrufen des Skripts mit dem Parameter /a spter angegeben werden. Ansonsten wird immer
:: B (oder der hier definierte Buchstabe) als Laufwerksbuchstabe verwendet.
SET DL=B

:: Entferne REM, um die Neuzuweisung des Laufwerksbuchstabens nach der Installation standardmig
:: zu deaktivieren. 
REM SET REASSIGN=NO

:: Entferne REM, um die Abfrage des Laufwerksbuchstabens fr das Ziel standardmig zu aktivieren.
:: Die Aktivierung dieser Option deaktivert auch die Neuzuweisung des Laufwerksbuchstabens nach
:: der Installation.
REM SET MDL=1

:: OS-Check
VER | find "Microsoft Windows XP [Version 5.1.2600]" > nul
IF %errorlevel% EQU 0 (SET OS=WINXP) ELSE (SET OS=NOXP)
IF [%OS%]==[WINXP] SET HD2=XP & GOTO HEADER2

:: File-Check
IF NOT EXIST 7Z.DLL SET DLL7Z=1
IF NOT EXIST 7Z.EXE SET EXE7Z=1
IF NOT EXIST CHOICE4XP.EXE SET CHOIXP=1
IF NOT [%OS%]==[XP] SET CHOIXP=
IF NOT EXIST SYSLINUX.EXE SET SL=1
IF NOT EXIST vesamenu.c32 SET VM=1

IF [%DLL7Z%]==[1] SET FC=1
IF [%EXE7Z%]==[1] SET FC=1
IF [%CHOIXP%]==[1] SET FC=1
IF [%SL%]==[1] SET FC=1
IF [%VM%]==[1] SET FC=1

IF [%FC%]==[1] SET HD2=MISSED & GOTO HEADER2

:: Admin-Check
net localgroup administratoren | find /i "%username%" > nul
if errorlevel 1 SET HD2=noadmin & GOTO HEADER2

:: Admin-Check 2
whoami /groups | find "S-1-16-12288" > nul 
if errorlevel 1 SET HD2=noadmin & GOTO HEADER2

:: Admin-Check 3
for /f "tokens=1,2*" %%a in ('bcdedit') do set VAR=%%a
if [%VAR%]==[Zugriff] SET HD2=noadmin & GOTO HEADER2


:: Parameter-Check
IF not [%2]==[] SET SYNERR=1
IF [%1]==[/?] SET HD2=HELP & GOTO HEADER2
IF /i [%1]==[/a] SET MDL=1
IF /i [%1]==[/a] SET SYNCHK=OK
IF [%1]==[] SET SYNCHK=OK
IF NOT DEFINED SYNCHK SET SYNERR=1
IF [%SYNERR%]==[1] SET HD2=HELP & GOTO HEADER2

SET HD1=START

:HEADER1
cls
title Bankix2Flash %Bix2FVer%
color 17
Echo.
Echo  - Bankix2Flash                                                        %Bix2FVer% -
GOTO %HD1%

:HEADER2
Echo Bankix2Flash %Bix2FVer%, Copyright (C) 2012 Madnex
Echo Batch-Skript zum Installieren der Bankix Linux Distribution der Zeitschrift
Echo c't auf einem USB-Stick oder einer SD-Karte.
Echo Dieses Batch-Skript wurde unter den Bedingungen der GNU GPL verffentlicht.
GOTO %HD2%

:START
Echo.
Echo Durch dieses Skript ist es mit wenig Aufwand mglich die Linux Distribution
Echo Bankix von der Zeitschrift c't auf einen USB-Stick oder eine SD-Karte zu
Echo bertragen, den Datentrger bootfhig zu machen und das ursprngliche Boot-
Echo Men zu erhalten. Ganz nebenbei werden gewisse Unzulnglichkeiten umgangen,
Echo die Unetbootin und hnliche Programme aufweisen.
Echo.
Echo       Dieses Skript ist unter den Bedingungen der GNU GPL verffentlicht.
Echo.
Echo    Ich bernehme keine Verantwortung fr eventuellen Datenverlust, der durch
Echo          falsche Benutzereingaben oder Fehler im Skript entstanden ist.
Echo.
Echo            Die Benutzung dieses Skripts geschieht auf eigene Gefahr!
Echo.
Echo Zum Fortfahren, drcke die Taste [W] fr weiter. Ansonsten [A] fr Abbrechen.
Echo.
choice /C:WA /N /M "Eingabe (W oder A): "

IF ERRORLEVEL 2 GOTO ABBRUCH
IF ERRORLEVEL 1 GOTO ISODETECT

:ISODETECT

If not exist *.iso SET HD1=NOISO & GOTO HEADER1
If not exist *bankix*.iso SET HD1=NOBIXISO & GOTO HEADER1

dir /b /o-d *bankix*.iso > iso.txt

Set /p "LINE1="<"iso.txt"

For /F "tokens=* skip=1" %%a IN (iso.txt) DO echo %%a>>line2.txt
IF exist LINE2.txt set /p "LINE2="<"line2.txt"

For /F "tokens=* skip=2" %%a IN (iso.txt) DO echo %%a>>line3.txt
IF exist LINE3.txt set /p "LINE3="<"line3.txt"

For /F "tokens=* skip=3" %%a IN (iso.txt) DO echo %%a>>line4.txt
IF exist LINE4.txt set /p "LINE4="<"line4.txt"

del iso.txt
IF exist line2.txt del line2.txt
IF exist line3.txt del line3.txt
IF exist line4.txt del line4.txt

IF not "%LINE2%"=="" SET HD1=MULTIISO & GOTO HEADER1
SET HD1=ONEISO & GOTO HEADER1

:ONEISO
Echo.
Echo Die automatische Erkennung hat folgende Datei gefunden:
Echo.
Echo       %LINE1%
Echo.
Echo Ist das die richtige ISO-Datei? 
Echo. 
Echo Fr Ja, bitte die Taste [J] drcken (das fhrt zum nchsten Menpunkt, der
Echo Auswahl des Ziellaufwerks). Fr Nein, Die Taste [N] drcken (das ermglicht
Echo die manuelle Eingabe des Dateinamens). Mit Drcken der Taste [A] kann das
Echo Skript an dieser Stelle abgebrochen werden.
Echo.
choice /C:JNMA /N /M "Eingabe (J, N oder A): "

IF ERRORLEVEL 4 GOTO ABBRUCH
IF ERRORLEVEL 3 GOTO MANUELL
IF ERRORLEVEL 2 GOTO MANUELL
IF ERRORLEVEL 1 GOTO ISO1

:MULTIISO
Echo.
Echo Die automatische Erkennung hat mehrere Bankix.iso Dateien gefunden (bis zu vier
Echo knnen vom Skript erkannt werden). Whle bitte durch Drcken der entsprechenden
Echo Ziffer die Datei aus, die verwendet werden soll:
Echo. 
IF not "%LINE1%"=="" Echo     [1]  %LINE1%
IF not "%LINE2%"=="" Echo     [2]  %LINE2%
IF not "%LINE3%"=="" Echo     [3]  %LINE3%
IF not "%LINE4%"=="" Echo     [4]  %LINE4%
Echo.
Echo Durch Drcken der Taste [M] kann auf die manuelle Eingabe des Dateinames
Echo umgeschaltet und mit der Taste [A] das Skript an dieser Stelle abgebrochen
Echo werden.
Echo.

IF not "%LINE4%"=="" choice /C:MA1234 /N /M "Eingabe (1, 2, 3, 4, M oder A): "
IF not "%LINE4%"=="" goto ELADMISO
IF not "%LINE3%"=="" choice /C:MA123 /N /M "Eingabe (1, 2, 3, M oder A): "
IF not "%LINE3%"=="" goto ELADMISO
IF not "%LINE2%"=="" choice /C:MA12 /N /M "Eingabe (1, 2, M oder A): "
IF not "%LINE2%"=="" goto ELADMISO
IF not "%LINE1%"=="" choice /C:MA1 /N /M "Eingabe (1, M oder A): "
IF not "%LINE1%"=="" goto ELADMISO
IF "%LINE1%"=="" GOTO ERROR

:ELADMISO
IF ERRORLEVEL 6 GOTO ISO4
IF ERRORLEVEL 5 GOTO ISO3
IF ERRORLEVEL 4 GOTO ISO2
IF ERRORLEVEL 3 GOTO ISO1
IF ERRORLEVEL 2 GOTO ABBRUCH
IF ERRORLEVEL 1 GOTO MANUELL

:ISO1
SET BixISO=%LINE1%
SET HD1=SELECTLW & GOTO HEADER1

:ISO2
SET BixISO=%LINE2%
SET HD1=SELECTLW & GOTO HEADER1

:ISO3
SET BixISO=%LINE3%
SET HD1=SELECTLW & GOTO HEADER1

:ISO4
SET BixISO=%LINE4%
SET HD1=SELECTLW & GOTO HEADER1

:NOISO
color 47
Echo.
Echo Die automatische Erkennung hat keine ISO-Datei gefunden! Die Bankix-ISO-Datei
Echo muss sich im selben Ordner wie das Bix2F-Skript befinden.
GOTO CLOSE

:NOBIXISO
color 47
Echo.
Echo Die automatische Erkennung hat keine Bankix.iso Datei gefunden!
GOTO MANUELL

:MANUELL
Echo.
Echo Gib bitte die exakte Dateibezeichnung inkl. der Dateierweiterung (.iso) ein.
Echo.
Echo Folgende ISO-Dateien befinden sich im Skript-Ordner:
Echo.

dir /b /o-d *.iso

Echo.
SET /P BixISO=Eingabe: 

IF not defined BixISO GOTO MANERROR

IF not exist %BixISO% GOTO MANERROR
SET HD1=SELECTLW & GOTO HEADER1

:MANERROR
title Fehler:
color 47
Echo.
Echo Die von dir angegebene Datei existiert nicht!
Echo.
Echo Durch Drcken der Taste [M] kannst du die manuelle Eingabe erneut versuchen.
Echo Mit dem Drcken der Taste [A] kann das Skript an dieser Stelle abgebrochen
Echo werden.
Echo.
choice /C:MA /N /M "Eingabe (M oder A): "

IF ERRORLEVEL 2 GOTO ABBRUCH
IF ERRORLEVEL 1 SET HD1=MANUELL & GOTO HEADER1

:SELECTLW
Echo LIST DISK > list.txt
Echo EXIT >> list.txt

diskpart /s list.txt
del list.txt

Echo.
Echo Gib bitte die Datentrgernummer des Laufwerks (USB-Stick oder SD-Karte) ein,
Echo auf das Bankix installiert werden soll. Die Nummer des zu verwendenden
Echo Laufwerks ist in der oben angezeigten Auflistung ersichtlich (relativ leicht
Echo zu erkennen an der Gre des Laufwerks).
Echo.
Echo Beachte, dass die Daten auf dem ausgewhlten Laufwerk im spteren Verlauf des
Echo Skripts vollstndig gelscht werden! Eine falsche Eingabe kann somit zu
Echo Datenverlust fhren! 
Echo.
Echo Nach der Eingabe der Datentrgernummer folgt eine Kontrolle der eingegebenen
Echo Daten oder, falls das Skipt mit dem Paramter /a gestartet wurde, vorher die
Echo Mglichkeit den Laufwerksbuchstaben des Ziels anzugeben. Bei der Kontrolle
Echo kann die Formatierung ausgefhrt oder das Skript abgebrochen werden.
Echo. 
:SETDEV
SET /P DEV=Eingabe: 

for /f "delims=0123456789" %%i in ("%DEV%") do set "DEV="
IF not defined DEV ( 
	title Fehler:
	color 47
	Echo.
	Echo Gib bitte eine Datentrgernummer ein.
	Echo.
	GOTO SETDEV
)

IF "%MDL%"=="1" SET HD1=SELECTDL & GOTO HEADER1

GOTO PREFOR

:SELECTDL
Echo.
Echo Gib bitte einen noch freien oder den aktuell zugewiesenen Laufwerksbuchstaben
Echo des Ziellaufwerks (USB-Stick oder SD-Karte) ein. Es darf nur der Buchstabe
Echo OHNE Doppelpunkt eingegeben werden.
Echo.

:SETDL
SET /P DL=Eingabe: 

for /f "delims=abdefghijklmnopqrstuvwxyzABDEFGHIJKLMNOPQRSTUVWXYZ" %%i in ("%DL%") do set "DL="
IF not defined DL ( 
	title Fehler:
	color 47
	Echo.
	Echo Der Laufwerksbuchstabe muss ohne Doppelpunkt eingegeben werden.
	Echo.
	GOTO SETDL
)

:PREFOR
Echo SELECT DISK %DEV% > format.txt
Echo CLEAN >> format.txt
Echo CREATE PART PRI >> format.txt
Echo SELECT PART 1 >> format.txt
Echo FORMAT FS=FAT32 LABEL="Bankix" QUICK >> format.txt
Echo ASSIGN LETTER=%DL% >> format.txt
Echo EXIT >> format.txt

SET HD1=RUN & GOTO HEADER1

:RUN
Echo.
Echo Folgende Parameter hast du eingegeben:
Echo.
Echo   Name der Bankix-ISO-Datei: %BixISO%
Echo   Nummer des ausgewhlten Datentrgers: %DEV%
IF "%MDL%"=="1" Echo   Laufwerksbuchstabe des Ziels: %DL%:
Echo.
Echo Wenn das alles richtig ist, kannst du jetzt mit dem Drcken der Taste [R] das
Echo Formatieren des USB-Sticks / der SD-Karte und das berspielen von Bankix aus-
Echo fhren lassen. 
Echo.
Echo Hierbei wird das ausgewhlte Laufwerk vollstndig gelscht!
Echo.
Echo Mit dem Drcken der Taste [A] kann das Skript jetzt beendet werden.
Echo.
choice /C:RA /N /M "Eingabe (R oder A): "

IF ERRORLEVEL 2 GOTO ABBRUCH
IF ERRORLEVEL 1 SET HD1=FORMAT & GOTO HEADER1

:FORMAT
color 08
Echo.
Echo Das ausgewhlte Laufwerk wird mittels Diskpart formatiert...

echo %date:~0% - %time:~0,8% Uhr > Log.txt

diskpart /s format.txt >> Log.txt

IF %ERRORLEVEL% NEQ 0 GOTO DPERROR

Echo.
Echo Die Formatierung wurde erfolgreich abgeschlossen.
del format.txt

Echo.
Echo Bankix wird auf das ausgewhlte Laufwerk kopiert...
Echo Bitte ein wenig Geduld. Das kann ein paar Minuten dauern.

Echo [BOOT]\Bootable_NoEmulation.img > exclude.txt
Echo autorun.inf >> exclude.txt
Echo isolinux\isolinux.bin >> exclude.txt

7z x %BixISO% -o%DL%:\ -x@exclude.txt >> Log.txt
IF ERRORLEVEL 1 SET ERROR=7ZE
del exclude.txt
Echo.
IF "%ERROR%"=="7ZE" (GOTO 7ZERROR) ELSE (Echo Die Daten wurden erfolgreich auf das Ziellaufwerk kopiert.)

:SYSLINUX
syslinux.exe -fma -r -d \isolinux %DL%:
IF %ERRORLEVEL% NEQ 0 GOTO SLERROR
copy /y vesamenu.c32 %DL%:\isolinux\ > NUL
pushd %DL%:\
ren "isolinux" "syslinux"
cd syslinux
ren isolinux.cfg syslinux.cfg
popd
Echo.
Echo Der Syslinux Boot-Loader wurde installiert.

IF [%MDL%]==[1] GOTO NOREASSIGN
IF /i [%REASSIGN%]==[NO] GOTO NOREASSIGN

:REASSIGN
Echo SELECT DISK %DEV% > assign.txt
Echo SELECT PART 1 >> assign.txt
Echo ASSIGN >> assign.txt
Echo EXIT >> assign.txt

diskpart /s assign.txt >> Log.txt
IF %ERRORLEVEL% NEQ 0 GOTO AERROR
del assign.txt

:NOREASSIGN
Echo. >> Log.txt
Echo %time:~0,8% Uhr >> Log.txt

IF "%ERROR%"=="7ZE" GOTO 7ZE
GOTO NOERROR

:ABBRUCH
color 07
Echo.
Echo Das Skript wurde durch den Benutzer abgebrochen.
GOTO CLOSE

:ERROR
title Fehler:
color 47
Echo.
Echo Fehler:
Echo Es ist ein Fehler aufgetreten. Das Skript wurde beendet.
GOTO CLOSE

:DPERROR
title Fehler:
color 47
Echo.
Echo Fehler:
Echo Es ist ein Fehler beim Formatieren aufgetreten.
Echo Das Skript wurde beendet.
GOTO CLOSE

:AERROR
title Fehler:
color 47
Echo.
Echo Fehler:
Echo Es ist ein Fehler beim Zuweisen des Laufwerksbuchstabens aufgetreten.
Echo Das Skript wurde beendet.
GOTO CLOSE

:SLERROR
title Fehler:
color 47
Echo Fehler:
Echo Es ist ein Fehler beim Schreiben des Boot-Codes aufgetreten.
Echo Das Skript wurde beendet.
GOTO CLOSE

:7ZERROR
title Fehler:
color 47
Echo Fehler:
Echo Es ist ein Fehler beim Extrahieren der Dateien aus der ISO-Datei aufgetreten.
Echo Es muss kein kritischer Fehler sein und Bankix kann trotzdem funktionieren.
Echo.
Echo Was genau fr ein Fehler aufgetreten ist, kann in der Datei Log.txt nach-
Echo geprft werden.
GOTO SYSLINUX

:7ZE
Echo.
Echo Bankix wurde vermutlich erfolgreich auf dem USB-Stick bzw. der SD-Karte
Echo installiert.
GOTO CLOSE

:NOERROR
color 27
Echo.
Echo Bankix wurde erfolgreich auf dem USB-Stick bzw. der SD-Karte installiert.
GOTO CLOSE

:NOADMIN
title Fehler:
color 47
Echo.
Echo Fehler:
Echo Das Skript wurde ohne Admin-Rechte gestartet. Damit das Skript funktionieren
Echo kann, sind Admin-Rechte unbedingt erforderlich.
GOTO CLOSE

:XP
title Fehler:
color 47
Echo.
Echo Fehler:
Echo Als Betriebssystem wurde Windows XP erkannt. 
Echo Das Skript funktioniert unter Windows XP leider nicht, da die Diskpart Version
Echo von Windows XP keine per USB angeschlossenen Laufwerke untersttzt und der
Echo "choice"-Befehl von Microsoft eingespart wurde. 
GOTO CLOSE

:MISSED
title Fehler:
color 47
Echo.
Echo Fehler:
Echo Es konnten nicht alle fr die Funktion des Skripts notwendigen Dateien gefunden
Echo werden. Folgende Dateien fehlen:
Echo.
IF [%DLL7Z%]==[1] Echo       7z.dll
IF [%EXE7Z%]==[1] Echo       7z.exe
IF [%SL%]==[1] Echo       Syslinux.exe
IF [%VM%]==[1] Echo       vesamenu.c32
Echo.
Echo Falls das Skript per Mausklick mit Administrator-Rechten gestartet wurde, kann
Echo es sein, dass das Arbeitsverzeichnis pltzlich ein anderes ist und deshalb die
Echo Dateien nicht gefunden werden. In diesem Fall bitte das Skript ber die mit
Echo Administrator-Rechten gestartete Konsole aufrufen.
GOTO CLOSE

:HELP
Echo.
IF [%SYNERR%]==[1] Echo Syntaxfehler...
IF [%SYNERR%]==[1] Echo.
Echo Bix2f [/a] ^| [/?]
Echo.
Echo  - /a  Ermglicht das manuelle Setzen des Laufwerksbuchstabens fr das Ziel.
Echo        Standardmig wird fr das Ziel temporr der Laufwerksbuchstabe B: ver-
Echo        wendet. Ist dieser bereits belegt oder bricht das Skript mit einer
Echo        Fehlermeldung ab, die auf ein Problem beim Zuweisen des Laufwerksbuch-
Echo        stabens zurckgeht, kann durch Setzen dieses Schalters ein anderer, noch
Echo        freier oder dem Ziellaufwerk aktuell vergebener Buchstabe im Verlauf des
Echo        Skripts angegeben werden. 
Echo  - /?  Zeigt diesen Hilfetext an.
GOTO EOF

:CLOSE
Echo.
Echo  -----------------------------------------------------------------------------
Echo   Die folgende Abfrage dient dazu das Konsolenfenster nach der Beendigung des
Echo     durch einen Mausklick gestarteten Skripts offen zu halten, um eventuelle
Echo                         Fehlermeldungen sehen zu knnen.
Echo  -----------------------------------------------------------------------------
Echo.
Echo Mit dem Drcken der Taste [X] wird das Skript beendet und das Konsolenfenster
Echo gegebenenfalls geschlossen (geschieht nur, wenn das Skript per Mausklick
Echo gestartet wurde).
Echo.
IF [%OS%]==[NOXP] choice /C:X /N /M "Eingabe (X): "
IF [%OS%]==[WINXP] choice4xp /C:X /N "Eingabe (X): "

IF ERRORLEVEL 1 GOTO EXIT

:EXIT
Echo.
Echo Das Konsolenfenster kann nun mit der Eingabe des Befehls EXIT geschlossen
Echo werden.
GOTO EOF

:: - Text-Schablone 
Echo ͼ

:EOF
IF exist assign.txt del assign.txt
IF exist format.txt del format.txt
title 
color 07
ENDLOCAL